#!/bin/bash
#
function check_connectivity {
	LOCAL_IP="$(hostname -I)"
    while [ "$LOCAL_IP" == "" ]; do
	    sleep 30
        LOCAL_IP="$(hostname -I)"
    done
    WAIT_TIME=1m
    FLAG=0
    TEST_IPS="educaciodigital.cat ubuntu.com wikipedia.org"
    TARGET=($(echo $TEST_IPS))
    N_TARGET=${#TARGET[@]}
    let 'N_TARGET -=1'
    TEST_PORT=443
    CURRENT_TEST_IP=0
    while [ $FLAG -eq 0 ];
    do
    TESTIP=${TARGET[$CURRENT_TEST_IP]}
        if [ -z "$(nmap  -p $TEST_PORT $TESTIP  2>/dev/null |grep open)" ]; then
	        if [ $CURRENT_TEST_IP -lt $N_TARGET ]; then   
	            let 'CURRENT_TEST_IP +=1'
            else
                CURRENT_TEST_IP=0
                sleep $WAIT_TIME
            fi
        else
            FLAG=1
        fi
    done
}
#
# MAIN
#
# DEFINICIÓ DE VARIABLES
#
# VELOCITAT DESCÀRREGA 5 MByte/s (40 Mbits/s)
#
MES="$(date +%m)"
MES_I="06"
MES_F="08"
if [ "$MES" -ge "$MES_I" ] && [ "$MES" -le "$MES_F" ]; then
# 5M --> 5 Mbytes/s --> temps descàrrega aprox. ==> 21-22 min (la imatge ocupa 6.4 Gbytes).
	MAX_SPEED="5M"
else
# 128K  --> 128 Kbytes/s --> temps descàrrega aprox. ==> 14.56 hores (la imatge ocupa 6.4 Gbytes).
	MAX_SPEED="128K"
fi
OUTPUT_FILE="LINKAT_2204_UPGRADE.tar"
OUTPUT_DIRECTORY="/var/download"
ARIA2C_BIN="$(which aria2c)"
NICE_BIN="$(which nice)"
IONICE_BIN="$(which ionice)"
MD5SUM_BIN="$(which md5sum)"
CURL_BIN="$(which curl)"
TAR_BIN="$(which tar)"
# CANVIAR VALOR CHECKSUM TEORIC --> IMATGE CLONEZILLA + ISO CLONEZILLA
if [ "$(id -u)" != 0 ]; then
	exit 0
fi
if [ -f /opt/configuracio/linkat-2204-upgrade-control ];then
	exit 0
fi
if [ -z "$(grep "VERSIOMQ\|LK-EDC" /etc/environment)" ]; then
	exit 0
else
#
# CAL MIRAR LA VARIABLE VERSIOMQ PER DIFERENCIAR ENTRE MAQUETA ACER I LENOVO
# URL DE DESCÀRREGA ESPECÍFICAR PER A ACER I PER A LENOVO
#
	if [ -n "$(grep "REDES" /etc/environment)" ]; then
	# URL IMATGE REDES
		URL_TARGET="http://download-linkat.xtec.cat/1804_2_2204_edc/ACER_REDES/LINKAT_2204_UPGRADE.tar"
		URL_SUM="http://download-linkat.xtec.cat/1804_2_2204_edc/ACER_REDES/LINKAT_2204_UPGRADE.md5sum"
		URL_SUM_FILES="http://download-linkat.xtec.cat/1804_2_2204_edc/ACER_REDES/LINKAT_2204_UPGRADE_FILES.md5sum"
	else
	# URL IMATGE LENOVO
		URL_TARGET="http://download-linkat.xtec.cat/1804_2_2204_edc/LENOVO_300e/LINKAT_2204_UPGRADE.tar"
		URL_SUM="http://download-linkat.xtec.cat/1804_2_2204_edc/LENOVO_300e/LINKAT_2204_UPGRADE.md5sum"
		URL_SUM_FILES="http://download-linkat.xtec.cat/1804_2_2204_edc/LENOVO_300e/LINKAT_2204_UPGRADE_FILES.md5sum"
	fi
fi
OD="$(which od)"
BASE_RANDOM_TIME=60 # ESPEREM 1 MINUT DE BASE
MAX_RANDOM_TIME=900 # FINESTRA DE 15 MINUTS (900s). 
ESPERA=$($OD -A n -N 2 -t u2 /dev/urandom )
let 'ESPERA %= MAX_RANDOM_TIME' # mòdul
let 'ESPERA += BASE_RANDOM_TIME'
sleep $ESPERA # ESPERA = 60 + [ RANDOM 0-900 segons ]
#
# Check espai lliure en HD
#
DEVICE_SSD="$(mount |grep -i ext4 | grep -v opt | cut -d " " -f 1)"
USED_SPACE_PERCENT="$(df -h | grep -i "$DEVICE_SSD" | tr -s " " | cut -d " " -f 5 | tr -d \%)"
USED_TOLERANCE_PERCENT=75
#
# LENOVO PARTICIÓ ARREL  48 GB --> 75%= 36 Gb --> Lliure= 9 Gb
# ACER   PARTICIÓ ARREL 101 GB --> 75%= 75.75 Gb --> Lliure= 20.2 Gb
#
if [ "$((USED_SPACE_PERCENT))" -ge "$((USED_TOLERANCE_PERCENT))" ]; then
	exit 0
fi
#
# Check connectivity
#
check_connectivity
if [ -n "$($CURL_BIN -I $URL_TARGET 2>/dev/null  |grep -i not\ found)" ]; then
		exit 0
else
#
# XARXA DEPARTAMENT EDUCACIÓ --> 85.192.64.0/18
# RANG IPs: 85.192.64.1 - 85.192.127.254
# 
#	PUBLIC_IP="$(dig TXT +short o-o.myaddr.l.google.com @ns1.google.com | sed 's/\"//g' | grep 85.192)"
#	if [ -n "$PUBLIC_IP" ]; then
#		PUBLIC_IP_CHECK="$(echo $PUBLIC_IP |cut -d "." -f 3)"
#		if [ $PUBLIC_IP_CHECK -ge 64 ] && [ $PUBLIC_IP_CHECK -le 127 ]; then
#			TARGET_HOUR=16
#			CURRENT_HOUR="$(date +%H)"
#			if [ $CURRENT_HOUR -lt $TARGET_HOUR ]; then
#				exit 0
#			fi
#		fi
#	fi
	#WIFI_DEVICE="$(nmcli -t -f NAME,DEVICE con show --active |cut -d ":" -f 2)"
	CONNECTION_NAME="$(nmcli -t -f NAME,DEVICE con show --active | cut -d ":" -f 1)"
	if [[ -n $CONNECTION_NAME ]]; then
		if [[ -n $(grep -i gencat <<< $CONNECTION_NAME) ]] || [[ -n $(grep -i docent <<< $CONNECTION_NAME) ]]; then
			TARGET_HOUR="16"
			CURRENT_HOUR="$(date +%H)"
			if [ "$CURRENT_HOUR" -ge "$TARGET_HOUR" ]; then
				MAX_SPEED="5M"
			fi
		else
			MAX_SPEED="5M"
		fi
	else
		exit 0
	fi
	if [ -d "$OUTPUT_DIRECTORY" ]; then
		"$NICE_BIN" -n 19 "$IONICE_BIN" -c2 -n7 $ARIA2C_BIN -c --auto-file-renaming=false -x 2 -s 2 --dir=$OUTPUT_DIRECTORY --max-overall-download-limit=$MAX_SPEED -o $OUTPUT_FILE  $URL_TARGET >/dev/null 2>&1
	else
		exit 0
	fi
fi
#
if [ -z "$($CURL_BIN -I $URL_SUM 2>/dev/null  |grep -i not\ found)" ]; then
	CHECKSUM_TEORIC="$($CURL_BIN -s $URL_SUM |tr -s ' ' |cut -d ' ' -f 1)"
else
	exit 0
fi
if [ -f "$OUTPUT_DIRECTORY/$OUTPUT_FILE" ] && [ ! -f "$OUTPUT_DIRECTORY/$OUTPUT_FILE.aria2" ]; then
	CHECKSUM_CALCULAT="$($NICE_BIN -n 19 $IONICE_BIN -c2 -n7 $MD5SUM_BIN "$OUTPUT_DIRECTORY/$OUTPUT_FILE" | tr -s ' ' |cut -d ' ' -f 1)"
# ACTUALITZEM PARTICIÓ
	if [ "$CHECKSUM_CALCULAT" == "$CHECKSUM_TEORIC" ]; then
		if [ -n "$(grep mnt-recuperacio /etc/fstab)" ]; then
			if [ -z "$(mount |grep mnt-recuperacio)" ]; then
				mount /opt/configuracio/mnt-recuperacio
			fi
			if [ -n "$(mount |grep mnt-recuperacio)" ]; then
				if [ -e /opt/configuracio/mnt-recuperacio/clonezilla-custom.iso ]; then
					rm /opt/configuracio/mnt-recuperacio/clonezilla-custom.iso
				fi
				find /opt/configuracio/mnt-recuperacio/ -maxdepth 1 -type d -name "LK*" -exec rm -rf '{}' \;
 
				# ES COPIA EL PERFIL DE LA WIFI A LA PARTICIÓ DE RESTAURACIÓ
				#find /etc/NetworkManager/system-connections -type f -iname "*gencat*" -exec cp '{}' /opt/configuracio/mnt-recuperacio/ \;
				#
				"$NICE_BIN" -n 19 "$IONICE_BIN" -c2 -n7 $TAR_BIN -xf $OUTPUT_DIRECTORY/$OUTPUT_FILE --directory=/opt/configuracio/mnt-recuperacio							
				# CHECKSUM FITXERS COPIATS
				if [ -z "$($CURL_BIN -I $URL_SUM_FILES 2>/dev/null  |grep -i not\ found)" ]; then
					CHECKSUM_TEMP="$(mktemp)"
					$CURL_BIN --output $CHECKSUM_TEMP -s $URL_SUM_FILES |tr -s ' ' > /dev/null 2>&1
				else
					exit 0
				fi
				while IFS= read -r line
				do
					FILENAME_TEMP="$(echo "$line" |tr -s " " | cut -d " " -f 2)"
					CHECKSUM_TEMP_TEORIC="$(echo "$line" |tr -s " " | cut -d " " -f 1)"
					CHECKSUM_TEMP_CALCULAT="$($NICE_BIN -n 19 $IONICE_BIN -c2 -n7 $MD5SUM_BIN "$FILENAME_TEMP" | tr -s ' ' |cut -d ' ' -f 1)"
# ACTUALITZEM PARTICIÓ
					if [ "$CHECKSUM_TEMP_CALCULAT" != "$CHECKSUM_TEMP_TEORIC" ]; then
						exit 0
					fi	
				done < "$CHECKSUM_TEMP"
				rm "$CHECKSUM_TEMP"
				sleep 1
				umount /opt/configuracio/mnt-recuperacio
			fi
		fi
		if [ -f "$OUTPUT_DIRECTORY/$OUTPUT_FILE" ]; then
			rm "$OUTPUT_DIRECTORY/$OUTPUT_FILE"
		fi					
		echo 1 > /opt/configuracio/linkat-2204-upgrade-control

#
# ES REGISTRA EL PAQUET FICTICI CA - IMATGE LINKAT 22.04
#
		if [ ! -f /opt/configuracio/linkat-upgrade-2204-caf-check ]; then
	        check_connectivity
            if [ -n "$(pidof -s caf)" ]; then
				. /etc/profile.CA all
				sd_acmd AddInstallRecord "Imatge Linkat 22.04" "V1.0" "install" current current "Imatge" ""
				caf start sdagent amagent
				touch /opt/configuracio/linkat-upgrade-2204-caf-check
				chmod 644 /opt/configuracio/linkat-upgrade-2204-caf-check
				exit 0
			fi
		fi
	else
		if [ -f "$OUTPUT_DIRECTORY/$OUTPUT_FILE" ]; then
			rm "$OUTPUT_DIRECTORY/$OUTPUT_FILE"
		fi					
		if [ -f /opt/configuracio/linkat-2204-upgrade-control ]; then
			rm /opt/configuracio/linkat-2204-upgrade-control
		fi
		if [ -f /opt/configuracio/linkat-upgrade-2204-caf-check ]; then
			rm /opt/configuracio/linkat-upgrade-2204-caf-check
		fi
	fi
fi
exit 0
